Index: LMDZ6/trunk/DefLists/file_def_histhf_lmdz.xml
===================================================================
--- LMDZ6/trunk/DefLists/file_def_histhf_lmdz.xml	(revision 3346)
+++ LMDZ6/trunk/DefLists/file_def_histhf_lmdz.xml	(revision 3475)
@@ -1,5 +1,5 @@
 <file_definition>
     <file_group id="defile">
-        <file id="histhf" name="histhf" output_freq="6h" output_level="5" enabled="_AUTO_">
+        <file id="histhf" name="histhf" output_freq="3h" output_level="5" enabled="_AUTO_">
             
             <!-- VARS 1D -->
@@ -12,14 +12,14 @@
             <!-- VARS 2D -->
             <field_group operation="average" freq_op="1ts">
-                <field field_ref="phis" level="5" />
+                <field field_ref="phis" level="10" />
                 <field field_ref="aire" level="10" operation="once" />
-                <field field_ref="contfracATM" level="10" operation="once" />
-                <field field_ref="contfracOR" level="10" />
-                <field field_ref="flat" level="5" />
+                <field field_ref="contfracATM" level="5" operation="once" />
+                <field field_ref="contfracOR" level="5" />
+                <field field_ref="flat" level="10" />
                 <field field_ref="slp" level="10" />
                 <field field_ref="sza" level="10" />
                 <field field_ref="ptstar" level="10" />
                 <field field_ref="pt0" level="10" />
-                <field field_ref="tsol" level="5" />
+                <field field_ref="tsol" level="10" />
                 <field field_ref="t2m" level="5" />
                 <field field_ref="t2m_min" level="10" operation="minimum" />
@@ -34,9 +34,9 @@
                 <field field_ref="sicf" level="10" />
                 <field field_ref="q2m" level="5" />
-                <field field_ref="ustar" level="5" />
+                <field field_ref="ustar" level="10" />
                 <field field_ref="u10m" level="5" />
                 <field field_ref="v10m" level="5" />
                 <field field_ref="psol" level="5" />
-                <field field_ref="qsurf" level="10" />
+                <field field_ref="qsurf" level="5" />
                 <field field_ref="ustar_ter" level="10" />
                 <field field_ref="ustar_lic" level="10" />
@@ -58,5 +58,5 @@
                 <field field_ref="qsol" level="10" />
                 <field field_ref="ndayrain" level="10" operation="instant" />
-                <field field_ref="precip" level="10" />
+                <field field_ref="precip" level="5" />
                 <field field_ref="rain_fall" level="10" />
                 <field field_ref="rain_con" level="10" />
@@ -64,5 +64,5 @@
                 <field field_ref="plun" level="10" />
                 <field field_ref="pluc" level="10" />
-                <field field_ref="snow" level="10" />
+                <field field_ref="snow" level="5" />
                 <field field_ref="evap" level="10" />
                 <field field_ref="evap_ter" level="10" />
@@ -74,5 +74,5 @@
                 <field field_ref="tops" level="10" />
                 <field field_ref="tops0" level="10" />
-                <field field_ref="topl" level="5" />
+                <field field_ref="topl" level="10" />
                 <field field_ref="topl0" level="10" />
                 <field field_ref="SWupTOA" level="10" />
@@ -102,12 +102,12 @@
                 <field field_ref="LWdnSFC" level="10" />
                 <field field_ref="LWdnSFCclr" level="10" />
-                <field field_ref="bils" level="5" />
-                <field field_ref="bils_tke" level="5" />
-                <field field_ref="bils_diss" level="5" />
-                <field field_ref="bils_ec" level="5" />
-                <field field_ref="bils_kinetic" level="5" />
-                <field field_ref="bils_enthalp" level="5" />
-                <field field_ref="bils_latent" level="5" />
-                <field field_ref="sens" level="5" />
+                <field field_ref="bils" level="10" />
+                <field field_ref="bils_tke" level="10" />
+                <field field_ref="bils_diss" level="10" />
+                <field field_ref="bils_ec" level="10" />
+                <field field_ref="bils_kinetic" level="10" />
+                <field field_ref="bils_enthalp" level="10" />
+                <field field_ref="bils_latent" level="10" />
+                <field field_ref="sens" level="10" />
                 <field field_ref="sens_x" level="11" />
                 <field field_ref="sens_w" level="11" />
@@ -303,5 +303,6 @@
                 <field field_ref="tpote" level="10" />
                 <field field_ref="SWnetOR" level="10" />
-                <field field_ref="LWdownOR" level="10" />
+                <field field_ref="SWdownOR" level="5" />
+                <field field_ref="LWdownOR" level="5" />
                 <field field_ref="snowl" level="10" />
                 <field field_ref="cape_max" level="10" operation="maximum" />
@@ -406,5 +407,5 @@
                 <field field_ref="ftime_deepcv" level="10" />
                 <field field_ref="f0_th" level="10" />
-                <field field_ref="zmax_th" level="5" />
+                <field field_ref="zmax_th" level="10" />
                 <field field_ref="rsut4co2" level="10" />
                 <field field_ref="rlut4co2" level="10" />
@@ -475,5 +476,5 @@
                 <field field_ref="iwcon" level="10" />
                 <field field_ref="temp" level="10" />
-                <field field_ref="theta" level="5" />
+                <field field_ref="theta" level="10" />
                 <field field_ref="ovap" level="10" />
                 <field field_ref="ovapinit" level="10" />
@@ -482,6 +483,6 @@
                 <field field_ref="geop" level="10" />
                 <field field_ref="geoph" level="10" />
-                <field field_ref="vitu" level="5" />
-                <field field_ref="vitv" level="5" />
+                <field field_ref="vitu" level="10" />
+                <field field_ref="vitv" level="10" />
                 <field field_ref="vitw" level="6" />
                 <field field_ref="pres" level="10" />
@@ -513,10 +514,10 @@
                 <field field_ref="reffclwc" level="10" />
                 <field field_ref="lcc3d" level="10" />
-                <field field_ref="lcc3dcon" level="5" />
-                <field field_ref="lcc3dstra" level="5" />
-                <field field_ref="cldwatmxrat" level="5" />
-                <field field_ref="icc3dcon" level="5" />
-                <field field_ref="icc3dstra" level="5" />
-                <field field_ref="cldicemxrat" level="5" />
+                <field field_ref="lcc3dcon" level="10" />
+                <field field_ref="lcc3dstra" level="10" />
+                <field field_ref="cldwatmxrat" level="10" />
+                <field field_ref="icc3dcon" level="10" />
+                <field field_ref="icc3dstra" level="10" />
+                <field field_ref="cldicemxrat" level="10" />
                 <field field_ref="clwcon" level="10" />
                 <field field_ref="Ma" level="10" />
@@ -584,6 +585,6 @@
                 <field field_ref="dtlw0" level="10" />
                 <field field_ref="dtec" level="10" />
-                <field field_ref="duvdf" level="5" />
-                <field field_ref="dvvdf" level="5" />
+                <field field_ref="duvdf" level="10" />
+                <field field_ref="dvvdf" level="10" />
                 <field field_ref="duoro" level="10" />
                 <field field_ref="dvoro" level="10" />
@@ -628,8 +629,8 @@
                 <field field_ref="rsdcs4co2" level="10" />
                 <field field_ref="rldcs4co2" level="10" />
-                <field field_ref="treedrg_ter" level="5" />
-                <field field_ref="treedrg_lic" level="5" />
-                <field field_ref="treedrg_oce" level="5" />
-                <field field_ref="treedrg_sic" level="5" />
+                <field field_ref="treedrg_ter" level="10" />
+                <field field_ref="treedrg_lic" level="10" />
+                <field field_ref="treedrg_oce" level="10" />
+                <field field_ref="treedrg_sic" level="10" />
                 <field field_ref="tke" level="5" />
                 <field field_ref="tke_ter" level="10" />
@@ -654,5 +655,5 @@
             <!-- VARS 3D -->
             <field_group operation="average" freq_op="1ts" grid_ref="grid_glo_spectband">
-                <field field_ref="solbnd" level="4" />
+                <field field_ref="solbnd" level="10" />
             </field_group>
 