Index: LMDZ6/trunk/libf/phylmd/cv3a_uncompress.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/cv3a_uncompress.F90	(revision 3006)
+++ LMDZ6/trunk/libf/phylmd/cv3a_uncompress.F90	(revision 3496)
@@ -10,6 +10,6 @@
                            asupmaxmin, &
                            da, phi, mp, phi2, d1a, dam, sigij, &                ! RomP+AC+jyg
-                           clw, elij, evap, ep, epmlmMm, eplaMm, &              ! RomP
-                           wdtrainA, wdtrainM, &                                ! RomP
+                           qta, clw, elij, evap, ep, epmlmMm, eplaMm, &         ! RomP+jyg
+                           wdtrainA, wdtrainS, wdtrainM, &                      ! RomP
                            qtc, sigt,          &
                            epmax_diag, & ! epmax_cape
@@ -24,6 +24,6 @@
                            asupmaxmin1, &
                            da1, phi1, mp1, phi21, d1a1, dam1, sigij1, &         ! RomP+AC+jyg
-                           clw1, elij1, evap1, ep1, epmlmMm1, eplaMm1, &        ! RomP
-                           wdtrainA1, wdtrainM1, &                              ! RomP
+                           qta1, clw1, elij1, evap1, ep1, epmlmMm1, eplaMm1, &  ! RomP+jyg
+                           wdtrainA1, wdtrainS1, wdtrainM1, &                   ! RomP
                            qtc1, sigt1, &
                            epmax_diag1) ! epmax_cape
@@ -75,4 +75,5 @@
   REAL, DIMENSION (nloc, nd), INTENT (IN)            :: d1a, dam               !RomP
   REAL, DIMENSION (nloc, nd, nd), INTENT (IN)        :: sigij                  !RomP
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: qta                    !jyg
   REAL, DIMENSION (nloc, nd), INTENT (IN)            :: clw                    !RomP
   REAL, DIMENSION (nloc, nd, nd), INTENT (IN)        :: elij                   !RomP
@@ -81,5 +82,5 @@
   REAL, DIMENSION (nloc, nd), INTENT (IN)            :: eplamM                 !RomP+jyg
   REAL, DIMENSION (nloc, nd), INTENT (IN)            :: qtc, sigt              !RomP
-  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: wdtrainA, wdtrainM     !RomP
+  REAL, DIMENSION (nloc, nd), INTENT (IN)            :: wdtrainA, wdtrainS, wdtrainM     !RomP
 
   ! outputs:
@@ -111,4 +112,5 @@
   REAL, DIMENSION (len, nd), INTENT (OUT)            :: d1a1, dam1 !RomP       !RomP
   REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: sigij1                 !RomP
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: qta1                   !jyg
   REAL, DIMENSION (len, nd), INTENT (OUT)            :: clw1                   !RomP
   REAL, DIMENSION (len, nd, nd), INTENT (OUT)        :: elij1                  !RomP
@@ -117,5 +119,5 @@
   REAL, DIMENSION (len, nd), INTENT (OUT)            :: eplamM1                !RomP+jyg
   REAL, DIMENSION (len, nd), INTENT (OUT)            :: qtc1, sigt1            !RomP
-  REAL, DIMENSION (len, nd), INTENT (OUT)            :: wdtrainA1, wdtrainM1   !RomP
+  REAL, DIMENSION (len, nd), INTENT (OUT)            :: wdtrainA1, wdtrainS1, wdtrainM1   !RomP
 
 
@@ -175,4 +177,5 @@
         d1a1(idcum(i), k) = d1a(i, k) !RomP
         dam1(idcum(i), k) = dam(i, k) !RomP
+        qta1(idcum(i), k) = qta(i, k) !jyg
         clw1(idcum(i), k) = clw(i, k) !RomP
         evap1(idcum(i), k) = evap(i, k) !RomP
@@ -180,4 +183,5 @@
         eplamM1(idcum(i), k) = eplamM(i, k) !RomP+jyg
         wdtrainA1(idcum(i), k) = wdtrainA(i, k) !RomP
+        wdtrainS1(idcum(i), k) = wdtrainS(i, k) !RomP
         wdtrainM1(idcum(i), k) = wdtrainM(i, k) !RomP
         qtc1(idcum(i), k) = qtc(i, k)
@@ -300,4 +304,5 @@
       d1a1(:, 1:nl) = d1a(:, 1:nl)            !RomP
       dam1(:, 1:nl) = dam(:, 1:nl)            !RomP
+      qta1(:, 1:nl) = qta(:, 1:nl)            !jyg
       clw1(:, 1:nl) = clw(:, 1:nl)            !RomP
       evap1(:, 1:nl) = evap(:, 1:nl)          !RomP
@@ -305,4 +310,5 @@
       eplamM1(:, 1:nl) = eplamM(:, 1:nl)       !RomP+jyg
       wdtrainA1(:, 1:nl) = wdtrainA(:, 1:nl)  !RomP
+      wdtrainS1(:, 1:nl) = wdtrainS(:, 1:nl)  !RomP
       wdtrainM1(:, 1:nl) = wdtrainM(:, 1:nl)  !RomP
       qtc1(:, 1:nl) = qtc(:, 1:nl)