Index: LMDZ6/trunk/DefLists/file_def_histhf_lmdz.xml
===================================================================
--- LMDZ6/trunk/DefLists/file_def_histhf_lmdz.xml	(revision 3477)
+++ LMDZ6/trunk/DefLists/file_def_histhf_lmdz.xml	(revision 3507)
@@ -1,5 +1,6 @@
+<!-- $Id$ -->
 <file_definition>
     <file_group id="defile">
-        <file id="histhf" name="histhf" output_freq="3h" output_level="5" enabled="_AUTO_" compression_level="4">
+        <file id="histhf" name="histhf" output_freq="3h" output_level="_AUTO_" enabled="_AUTO_" compression_level="2" sync_freq="3h">
             
             <!-- VARS 1D -->
@@ -11,5 +12,6 @@
         
             <!-- VARS 2D -->
-            <field_group operation="average" freq_op="1ts">
+            <field_group group_ref="remap_3h" >
+              <field_group grid_ref="grid_out" > 
                 <field field_ref="phis" level="10" />
                 <field field_ref="aire" level="10" operation="once" />
@@ -460,5 +462,27 @@
 
             <!-- VARS 3D -->
-            <field_group operation="average" freq_op="1ts" grid_ref="grid_glo_presnivs">
+            <field_group operation="average" grid_ref="grid_out_presnivs">
+                <field field_ref="tke" level="10" />
+                <field field_ref="tke_ter" level="10" />
+                <field field_ref="tke_lic" level="10" />
+                <field field_ref="tke_oce" level="10" />
+                <field field_ref="tke_sic" level="10" />
+                <field field_ref="tke_max_ter" level="10" operation="maximum" />
+                <field field_ref="tke_max_lic" level="10" operation="maximum" />
+                <field field_ref="tke_max_oce" level="10" operation="maximum" />
+                <field field_ref="tke_max_sic" level="10" operation="maximum" />
+                <field field_ref="l_mix_ter" level="10" />
+                <field field_ref="l_mix_lic" level="10" />
+                <field field_ref="l_mix_oce" level="10" />
+                <field field_ref="l_mix_sic" level="10" />
+                <field field_ref="l_mixmin_ter" level="10" />
+                <field field_ref="l_mixmin_lic" level="10" />
+                <field field_ref="l_mixmin_oce" level="10" />
+                <field field_ref="l_mixmin_sic" level="10" />
+                <field field_ref="treedrg_ter" level="10" />
+                <field field_ref="treedrg_lic" level="10" />
+                <field field_ref="treedrg_oce" level="10" />
+                <field field_ref="treedrg_sic" level="10" />
+
                 <field field_ref="cldtau" level="10" />
                 <field field_ref="cldemi" level="10" />
@@ -629,34 +653,14 @@
                 <field field_ref="rsdcs4co2" level="10" />
                 <field field_ref="rldcs4co2" level="10" />
-                <field field_ref="treedrg_ter" level="10" />
-                <field field_ref="treedrg_lic" level="10" />
-                <field field_ref="treedrg_oce" level="10" />
-                <field field_ref="treedrg_sic" level="10" />
-                <field field_ref="tke" level="5" />
-                <field field_ref="tke_ter" level="10" />
-                <field field_ref="tke_lic" level="10" />
-                <field field_ref="tke_oce" level="10" />
-                <field field_ref="tke_sic" level="10" />
-                <field field_ref="tke_max_ter" level="10" operation="maximum" />
-                <field field_ref="tke_max_lic" level="10" operation="maximum" />
-                <field field_ref="tke_max_oce" level="10" operation="maximum" />
-                <field field_ref="tke_max_sic" level="10" operation="maximum" />
-                <field field_ref="l_mix_ter" level="10" />
-                <field field_ref="l_mix_lic" level="10" />
-                <field field_ref="l_mix_oce" level="10" />
-                <field field_ref="l_mix_sic" level="10" />
-                <field field_ref="l_mixmin_ter" level="10" />
-                <field field_ref="l_mixmin_lic" level="10" />
-                <field field_ref="l_mixmin_oce" level="10" />
-                <field field_ref="l_mixmin_sic" level="10" />
-                <field field_ref="ozone_daylight" level="10" />
-            </field_group>
+              </field_group>
 
-            <!-- VARS 3D -->
-            <field_group operation="average" freq_op="1ts" grid_ref="grid_glo_spectband">
+              <!-- VARS 3D -->
+              <field_group operation="average" grid_ref="grid_out_spectband" >
                 <field field_ref="solbnd" level="10" />
-            </field_group>
-
+              </field_group>
+          </field_group>
+        
         </file>
+    
     </file_group>
 </file_definition>