Index: LMDZ6/trunk/DefLists/context_lmdz.xml
===================================================================
--- LMDZ6/trunk/DefLists/context_lmdz.xml	(revision 3517)
+++ LMDZ6/trunk/DefLists/context_lmdz.xml	(revision 3533)
@@ -23,8 +23,5 @@
   <file_definition src="./file_def_histhfCOSP_lmdz.xml"/>  
   <file_definition src="./file_def_histstrataer_lmdz.xml"/>
-
-
-
-
+  <file_definition src="./file_def_histdaystrataer_lmdz.xml"/>
 
   <!-- Define domains and groups of domains -->
@@ -74,10 +71,10 @@
     <axis id="spectband" standard_name="Sensor Band Central Radiation Wavenumber" unit="m-1"/>
     <axis id="axis_lat" standard_name="Latitude axis">
-      <reduce_domain operation="average" direction="iDir" />
+        <reduce_domain operation="average" direction="iDir" />
     </axis>
     <axis id="spectband" standard_name="Sensor Band Central Radiation Wavenumber" unit="m-1">
     </axis>
     <axis id="axis_lat" standard_name="Latitude axis">
-           <reduce_domain operation="average" direction="iDir" />
+        <reduce_domain operation="average" direction="iDir" />
     </axis>
 
@@ -103,19 +100,15 @@
     <grid id="klevp1_bnds"> <axis axis_ref="klevp1" /> <axis axis_ref="bnds" /> </grid>
 
-
      <grid id="grid_glo">
         <domain domain_ref="dom_glo" />
      </grid>
-
      <grid id="grid_out">
         <domain domain_ref="dom_out" />
      </grid>
 
-
      <grid id="grid_glo_presnivs">
         <domain domain_ref="dom_glo" />
         <axis axis_ref="presnivs" />
      </grid>
-
      <grid id="grid_out_presnivs">
         <domain domain_ref="dom_out" />
@@ -123,10 +116,8 @@
      </grid>
 
-
      <grid id="grid_glo_plev">
         <domain domain_ref="dom_glo" />
         <axis axis_ref="plev" />
      </grid>
-
      <grid id="grid_out_plev">
         <domain domain_ref="dom_out" />
@@ -134,15 +125,12 @@
      </grid>
 
-
      <grid id="grid_glo_spectband">
         <domain domain_ref="dom_glo" />
         <axis axis_ref="spectband" />
      </grid>
-
      <grid id="grid_out_spectband">
         <domain domain_ref="dom_out" />
         <axis axis_ref="spectband" />
      </grid>
-     
 
      <grid id="grid_glo_height">
@@ -155,5 +143,4 @@
      </grid>
 
-
      <grid id="grid_glo_heightmlev">
         <domain domain_ref="dom_glo" />
@@ -165,5 +152,4 @@
      </grid>
 
-
      <grid id="grid_glo_temp">
         <domain domain_ref="dom_glo" />
@@ -175,6 +161,4 @@
      </grid>
 
-
-
      <grid id="grid_glo_sza">
         <domain domain_ref="dom_glo" />
@@ -186,5 +170,4 @@
      </grid>
 
-
      <grid id="grid_glo_column">
         <domain domain_ref="dom_glo" />
@@ -195,5 +178,4 @@
         <axis axis_ref="column" />
      </grid>
-
 
 <!-- Define 4D grids for Cosp simulator -->
@@ -220,5 +202,4 @@
      </grid>
 
-
      <grid id="grid4Ddbze">
         <domain domain_ref="dom_glo" />
@@ -276,5 +257,4 @@
      </grid>
 
-
      <grid id="grid4Dcol2">
         <domain domain_ref="dom_glo" />
@@ -293,5 +273,4 @@
         <axis axis_ref="sza" />
      </grid>
-
      <grid id="grid4Dsza_out">
         <domain domain_ref="dom_out" />
Index: LMDZ6/trunk/DefLists/file_def_histdaystrataer_lmdz.xml
===================================================================
--- LMDZ6/trunk/DefLists/file_def_histdaystrataer_lmdz.xml	(revision 3533)
+++ LMDZ6/trunk/DefLists/file_def_histdaystrataer_lmdz.xml	(revision 3533)
@@ -0,0 +1,12 @@
+<file_definition>
+    <file_group id="defile">
+        <file id="histdaystrataer" name="histdaystrataer" output_freq="1d" output_level="5" enabled="_AUTO_" compression_level="4">
+
+            <field_group group_ref="fields_strataer_3D" operation="average" freq_op="1ts" level="1" />
+            <field_group group_ref="fields_strataer_2D" operation="average" freq_op="1ts" level="1" />
+            <field_group group_ref="fields_strataer_trac_3D" operation="average" freq_op="1ts" level="1" />
+            <field_group group_ref="fields_strataer_trac_2D" operation="average" freq_op="1ts" level="1" />
+            
+        </file>
+    </file_group>
+</file_definition>