Index: /LMDZ6/trunk/libf/dyn3d/gcm.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3d/gcm.F90	(revision 3578)
+++ /LMDZ6/trunk/libf/dyn3d/gcm.F90	(revision 3579)
@@ -241,4 +241,5 @@
        'GCM: AVANT iniacademic AVANT AVANT AVANT AVANT'
   if (.not.read_start) then
+     start_time=0.
      annee_ref=anneeref
      CALL iniacademic(vcov,ucov,teta,q,masse,ps,phis,time_0)
Index: /LMDZ6/trunk/libf/dyn3dmem/conf_gcm.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/conf_gcm.F90	(revision 3578)
+++ /LMDZ6/trunk/libf/dyn3dmem/conf_gcm.F90	(revision 3579)
@@ -25,5 +25,5 @@
   USE serre_mod, ONLY: clon,clat,grossismx,grossismy,dzoomx,dzoomy, &
                        alphax,alphay,taux,tauy
-  USE temps_mod, ONLY: calend
+  USE temps_mod, ONLY: calend, year_len
 
   IMPLICIT NONE
@@ -144,5 +144,16 @@
   !Config         
   calend = 'earth_360d'
+! initialize year_len for aquaplanets and 1D
   CALL getin('calend', calend)
+     if (calend == 'earth_360d') then
+        year_len=360
+      else if (calend == 'earth_365d') then
+        year_len=365
+      else if (calend == 'earth_366d') then
+        year_len=366
+      else 
+        year_len=1
+      endif
+  
 
   !Config  Key  = dayref
Index: /LMDZ6/trunk/libf/dyn3dmem/gcm.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/gcm.F90	(revision 3578)
+++ /LMDZ6/trunk/libf/dyn3dmem/gcm.F90	(revision 3579)
@@ -233,4 +233,5 @@
        'GCM: AVANT iniacademic AVANT AVANT AVANT AVANT'
   if (.not.read_start) then
+     start_time=0.
      annee_ref=anneeref
      CALL iniacademic_loc(vcov,ucov,teta,q,masse,ps,phis,time_0)
Index: /LMDZ6/trunk/libf/dyn3dmem/temps_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/dyn3dmem/temps_mod.F90	(revision 3578)
+++ /LMDZ6/trunk/libf/dyn3dmem/temps_mod.F90	(revision 3579)
@@ -13,4 +13,5 @@
   INTEGER   annee_ref
   INTEGER   day_ref
+  INTEGER   year_len
   REAL      dt ! (dynamics) time step (changes if doing Matsuno or LF step)
   REAL      jD_ref ! reference julian day date (beginning of experiment)
Index: /LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 3578)
+++ /LMDZ6/trunk/libf/dynphy_lonlat/phylmd/iniphysiq_mod.F90	(revision 3579)
@@ -31,5 +31,5 @@
   USE inifis_mod, ONLY: inifis
   USE time_phylmdz_mod, ONLY: init_time
-  USE temps_mod, ONLY: annee_ref, day_ini, day_ref, start_time, calend
+  USE temps_mod, ONLY: annee_ref, day_ini, day_ref, start_time, calend, year_len
   USE infotrac_phy, ONLY: init_infotrac_phy
   USE phystokenc_mod, ONLY: init_phystokenc
@@ -173,5 +173,5 @@
   ! Additional initializations for aquaplanets 
   IF (iflag_phys>=100) THEN
-    CALL iniaqua(klon_omp,iflag_phys)
+    CALL iniaqua(klon_omp,year_len,iflag_phys)
   END IF
 
Index: /LMDZ6/trunk/libf/phylmd/phyaqua_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phyaqua_mod.F90	(revision 3578)
+++ /LMDZ6/trunk/libf/phylmd/phyaqua_mod.F90	(revision 3579)
@@ -8,5 +8,5 @@
 CONTAINS
 
-  SUBROUTINE iniaqua(nlon, iflag_phys)
+  SUBROUTINE iniaqua(nlon,year_len,iflag_phys)
 
     ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -37,5 +37,5 @@
     USE mod_grid_phy_lmdz
     USE ioipsl_getin_p_mod, ONLY : getin_p
-    USE phys_cal_mod , ONLY: year_len
+    USE phys_cal_mod , ONLY: calend, year_len_phy => year_len 
     IMPLICIT NONE
 
@@ -44,5 +44,5 @@
     include "dimsoil.h"
 
-    INTEGER, INTENT (IN) :: nlon, iflag_phys
+    INTEGER, INTENT (IN) :: nlon, year_len, iflag_phys
     ! IM ajout latfi, lonfi
 !    REAL, INTENT (IN) :: lonfi(nlon), latfi(nlon)
@@ -129,6 +129,10 @@
     ! -------------------------------
 
-
+    !IF (calend .EQ. "earth_360d") Then
+      year_len_phy = year_len
+    !END IF
+    
     if (year_len.ne.360) then
+      write (*,*) year_len
       write (*,*) 'iniaqua: 360 day calendar is required !'
       stop
@@ -351,4 +355,19 @@
     alp_bl =0.
     treedrg(:,:,:)=0.
+
+    u10m = 0.
+    v10m = 0.
+
+    ql_ancien   = 0.
+    qs_ancien   = 0.
+    u_ancien    = 0.
+    v_ancien    = 0.
+    prw_ancien  = 0.
+    prlw_ancien = 0.
+    prsw_ancien = 0.  
+
+    ale_wake    = 0.
+    ale_bl_stat = 0.  
+
 
 !ym error : the sub surface dimension is the third not second : forgotten for iniaqua