Index: LMDZ5/branches/IPSLCM5A2.1/libf/dyn3d_common/infotrac.F90
===================================================================
--- LMDZ5/branches/IPSLCM5A2.1/libf/dyn3d_common/infotrac.F90	(revision 3576)
+++ LMDZ5/branches/IPSLCM5A2.1/libf/dyn3d_common/infotrac.F90	(revision 3606)
@@ -562,10 +562,10 @@
 
 
-    WRITE(lunout,*) trim(modname),': Information stored in infotrac :'
-    WRITE(lunout,*) trim(modname),': iadv  niadv tname  ttext :'
-    DO iq=1,nqtot
-       WRITE(lunout,*) iadv(iq),niadv(iq),&
-       ' ',trim(tname(iq)),' ',trim(ttext(iq))
-    END DO
+!    WRITE(lunout,*) trim(modname),': Information stored in infotrac :'
+!    WRITE(lunout,*) trim(modname),': iadv  niadv tname  ttext :'
+!    DO iq=1,nqtot
+!       WRITE(lunout,*) iadv(iq),niadv(iq),&
+!       ' ',trim(tname(iq)),' ',trim(ttext(iq))
+!    END DO
 
 !
@@ -599,10 +599,10 @@
       if (tnom_transp(iq) == 'air') then
         ! ceci est un traceur père
-        WRITE(lunout,*) 'Le traceur',iq,', appele ',trim(tnom_0(iq)),', est un pere'
+!        WRITE(lunout,*) 'Le traceur',iq,', appele ',trim(tnom_0(iq)),', est un pere'
         nqperes=nqperes+1
         iqpere(iq)=0
       else !if (tnom_transp(iq) == 'air') then
         ! ceci est un fils. Qui est son père?
-        WRITE(lunout,*) 'Le traceur',iq,', appele ',trim(tnom_0(iq)),', est un fils'
+!        WRITE(lunout,*) 'Le traceur',iq,', appele ',trim(tnom_0(iq)),', est un fils'
         continu=.true.
         ipere=1
@@ -610,6 +610,6 @@
           if (tnom_transp(iq) == tnom_0(ipere)) then
             ! Son père est ipere
-            WRITE(lunout,*) 'Le traceur',iq,'appele ', &
-      &          trim(tnom_0(iq)),' est le fils de ',ipere,'appele ',trim(tnom_0(ipere))
+!            WRITE(lunout,*) 'Le traceur',iq,'appele ', &
+!      &          trim(tnom_0(iq)),' est le fils de ',ipere,'appele ',trim(tnom_0(ipere))
             nqfils(ipere)=nqfils(ipere)+1  
             iqfils(nqfils(ipere),ipere)=iq
@@ -619,6 +619,6 @@
             ipere=ipere+1 
             if (ipere.gt.nqtot) then
-                WRITE(lunout,*) 'Le traceur',iq,'appele ', &
-      &          trim(tnom_0(iq)),', est orpelin.'
+!                WRITE(lunout,*) 'Le traceur',iq,'appele ', &
+!      &          trim(tnom_0(iq)),', est orpelin.'
                 CALL abort_gcm('infotrac_init','Un traceur est orphelin',1)
             endif !if (ipere.gt.nqtot) then
@@ -627,8 +627,8 @@
       endif !if (tnom_transp(iq) == 'air') then
     enddo !DO iq=1,nqtot
-    WRITE(lunout,*) 'infotrac: nqperes=',nqperes    
-    WRITE(lunout,*) 'nqfils=',nqfils
-    WRITE(lunout,*) 'iqpere=',iqpere
-    WRITE(lunout,*) 'iqfils=',iqfils
+!    WRITE(lunout,*) 'infotrac: nqperes=',nqperes    
+!    WRITE(lunout,*) 'nqfils=',nqfils
+!    WRITE(lunout,*) 'iqpere=',iqpere
+!    WRITE(lunout,*) 'iqfils=',iqfils
 
 ! Calculer le nombre de descendants à partir de iqfils et de nbfils
@@ -649,9 +649,9 @@
         endif !if (ipere.gt.0) then
       enddo !do while (continu)    
-      WRITE(lunout,*) 'Le traceur ',iq,', appele ',trim(tnom_0(iq)),' est un traceur de generation: ',generation
+!      WRITE(lunout,*) 'Le traceur ',iq,', appele ',trim(tnom_0(iq)),' est un traceur de generation: ',generation
     enddo !DO iq=1,nqtot
-    WRITE(lunout,*) 'infotrac: nqdesc=',nqdesc
-    WRITE(lunout,*) 'iqfils=',iqfils
-    WRITE(lunout,*) 'nqdesc_tot=',nqdesc_tot
+!    WRITE(lunout,*) 'infotrac: nqdesc=',nqdesc
+!    WRITE(lunout,*) 'iqfils=',iqfils
+!    WRITE(lunout,*) 'nqdesc_tot=',nqdesc_tot
 
 ! Interdire autres schémas que 10 pour les traceurs fils, et autres schémas
Index: LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/phys_output_write_mod.F90	(revision 3576)
+++ LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/phys_output_write_mod.F90	(revision 3606)
@@ -1009,6 +1009,6 @@
 !--OLIVIER
 !This is warranted by treating INCA aerosols as offline aerosols
-!       IF (new_aod .and. (.not. aerosol_couple)) THEN
-       IF (new_aod) THEN
+       IF (new_aod .and. (.not. aerosol_couple)) THEN
+!       IF (new_aod) THEN
           IF (flag_aerosol.GT.0) THEN
              CALL histwrite_phy(o_od550aer, od550aer)
Index: LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/phys_state_var_mod.F90	(revision 3576)
+++ LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/phys_state_var_mod.F90	(revision 3606)
@@ -455,4 +455,5 @@
       ALLOCATE(ratqs(klon,klev))
       ALLOCATE(pbl_tke(klon,klev+1,nbsrf+1))
+      pbl_tke(:,:,:) = 0. 
 !nrlmd<
       ALLOCATE(delta_tsurf(klon,nbsrf))
Index: LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/physiq_mod.F90
===================================================================
--- LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/physiq_mod.F90	(revision 3576)
+++ LMDZ5/branches/IPSLCM5A2.1/libf/phylmd/physiq_mod.F90	(revision 3606)
@@ -3359,10 +3359,8 @@
 
        call chemtime(itap+itau_phy-1, date0, dtime, itap)
-       IF (config_inca == 'aero' .OR. config_inca == 'aeNP') THEN
-          CALL AEROSOL_METEO_CALC( &
-               calday,pdtphys,pplay,paprs,t,pmflxr,pmflxs, &
-               prfl,psfl,pctsrf,cell_area, &
-               latitude_deg,longitude_deg,u10m,v10m)
-       END IF
+       CALL AEROSOL_METEO_CALC( &
+            calday,pdtphys,pplay,paprs,t,pmflxr,pmflxs, &
+            prfl,psfl,pctsrf,cell_area, &
+           latitude_deg,longitude_deg,u10m,v10m)
 
        zxsnow_dummy(:) = 0.0